set escape on
CREATE OR REPLACE PACKAGE BODY iv_mail
AS
    PROCEDURE init_msg(msg IN OUT message,send_to VARCHAR2,sent_from VARCHAR2,subject VARCHAR2)
    IS
    BEGIN
	msg.send_to:=send_to;
	msg.sent_from:=sent_from;
	DBMS_LOB.CREATETEMPORARY(msg.headers,TRUE);
	DBMS_LOB.CREATETEMPORARY(msg.msgbody,TRUE);
	add_header(msg,'Subject: '||subject);
    END;
    PROCEDURE add_header(msg IN OUT message,header VARCHAR2)
    IS
    BEGIN
	DBMS_LOB.WRITEAPPEND(msg.headers,LENGTH(header||CHR(10)),header||CHR(10));
    END;
    PROCEDURE write(msg IN OUT message,line VARCHAR2)
    IS
    BEGIN
	DBMS_LOB.WRITEAPPEND(msg.msgbody,LENGTH(line),line);
    END;
    PROCEDURE writeln(msg IN OUT message,line VARCHAR2)
    IS
    BEGIN
	DBMS_LOB.WRITEAPPEND(msg.msgbody,LENGTH(line||CHR(10)),line||CHR(10));
    END;
    PROCEDURE send(msg IN OUT message)
    IS
	res NUMBER;
    BEGIN
	add_header(msg,'From: '||msg.sent_from);
	add_header(msg,'To: '||msg.send_to);
        res:=IV_SEND_MAIL(msg.send_to,msg.sent_from,msg.headers,msg.msgbody);
	discard(msg);
    END;
    PROCEDURE discard(msg IN OUT message)
    IS
    BEGIN
	DBMS_LOB.FREETEMPORARY(msg.headers);
	DBMS_LOB.FREETEMPORARY(msg.msgbody);
    END;
END iv_mail;
/
show err
